uses
   Crt,
   Dos,
   _nwAPI;


type
  PropertyPecPtr = ^PropertyRec;
  PropertyRec =
  record
    NextPtr: PropertyPecPtr;
    PropName: String;
    PropertyValue: array[0..31] of Longint;
  end;


const
  TopPtr: PropertyPecPtr = NIL;
  CurrentPtr: PropertyPecPtr = NIL;
  CountProperty: Integer = 0;
  QueueProperty: array[1..3] of String[11] =
    ('Q_USERS', 'Q_OPERATORS', 'Q_SERVERS');


var
  QueueName, UserName, ServerName,
  ObjName, QueueDirPath: String;
  QueueStatus, NumberOfJobs, NumberOfServers,
  i, Major, Minor, Revision,
  MoreS, PropF, SNumber: Byte;
  CCode: Integer;
  StationList: array[0..24] of Word;
  ServerIDList: array[0..24] of Longint;
  Count,
  ObjType, QueueType, UserType: Word;
  SupervisorID, QueueID, UserID, ObjID: Longint;
  UserLogTime: array[0..6] of Byte;
  CreateNewQueue: Boolean;
  TempBuff: array[0..127] of Byte;


Function UpCaseStr(const S: String): String;
var
  Bt: Byte;
  Buff: String;
begin
  Buff[0] := S[0];
  for Bt := 1 to Length(S) do Buff[Bt] := UpCase(S[Bt]);
  UpCaseStr := Buff;
end;


Procedure Error(ErrCode: Integer; const Msg: String);
begin
  WriteLn(^G);
  if ErrCode <> 0 then
    WriteLn('訡 #', ErrCode, Msg)
  else
    WriteLn(Msg);
  Halt(1);
end;


Function YesOrNo(const Msg: String): Boolean;
const
  YorN: array[Boolean] of Char = ('N', 'Y');
var
  Ch: Char;
begin
  Write(Msg, '? (Y/N) ');
  repeat
    Ch := ReadKey;
    Ch := UpCase(Ch);
  until (Ch = 'Y') or (Ch = 'N');
  YesOrNo := Ch = 'Y';
  WriteLn(Ch);
end;


Function CheckQueueDirectory(DirStr: String): Boolean;
var
  LenDir: Byte absolute DirStr;
  F: File;
  Wr: Word;
begin
  while DirStr[LenDir] = '\' do Dec(LenDir);
  DirStr := DirStr + '\.';
  Assign(F, DirStr);
  GetFAttr(F, Wr);
  CheckQueueDirectory := ((Wr and Directory) = Directory);
end;


begin
  FillChar(ServerIDList, SizeOf(ServerIDList), 0);
  WriteLn(#13, #10,
          'Queue Create/Move 1.00   (C) 1994  ᠤ ..  ⥫.(35135) 9-71-15',
          #13, #10);



  i := ParamCount;
  if i = 1 then
    begin
      QueueName := UpCaseStr(ParamStr(1));
      QueueDirPath := 'SYS:SYSTEM';
    end
  else
    if i = 2 then
      begin
        QueueName := UpCaseStr(ParamStr(1));
        QueueDirPath := UpCaseStr(ParamStr(2));
      end
    else
      begin
        WriteLn('ᯮ짮: QMOVE Queue_Name [Full_Directory_Path]');
        WriteLn(' Queue_Name -  ᮧ/६頥 ।');
        WriteLn('    Full_Directory_Path -     ࠡ稩');
        WriteLn('⠫ ।');
        WriteLn('᫨ ࠬ Full_Directory_Path , ');
        WriteLn('ਭ ⠭⭮ ࠧ饭 ࠡ祣 ⠫');
        WriteLn('।  SYS:SYSTEM');
        WriteLn('ਬ: QMOVE QUEUE1 SYS:PUBLIC');
        WriteLn('          QMOVE QUEUE2');
        Halt;
      end;



  CCode := GetShellVersionInformation(Major, Minor, Revision);
  if (CCode <> 0) or (Major = 0) then
    Error(0, ' 㦥 窠 NetWare');


  if not CheckQueueDirectory(QueueDirPath) then
    Error(0, '  ⠫ ' + QueueDirPath);


  GetFileServerName(GetDefaultConnectionID, ServerName);
  CCode := GetConnectionInformation(GetConnectionNumber,
                   UserName, UserType, UserID, UserLogTime);
  if CCode <> 0 then Error(CCode, ' ⨢ ᮥ');
  if Length(UserName) = 0 then UserName := 'NOT-LOGGED-IN';
  WriteLn(' ꥪ ', UserName, '  ࢥ ', ServerName);


  if not SupervisorEquivalent then Error(0, ' ࠢ 㯥ࢨ');


  CreateNewQueue := False;
  QueueType := OBJ_PrintQueue;
  CCode := GetBinderyObjectID(QueueName, OBJ_PrintQueue, QueueID);
  if CCode = ERR_NoSuchObject then
    begin
      QueueType := OBJ_JobQueue;
      CCode := GetBinderyObjectID(QueueName, OBJ_JobQueue, QueueID);
      if CCode = ERR_NoSuchObject then
        begin
          CCode := 0;
          if not YesOrNo('। ' + QueueName +
                         '  .  ') then Halt
          else
            begin
              CreateNewQueue := True;
              QueueType := OBJ_PrintQueue;
            end;
        end;
    end;
  if CCode <> 0 then Error(CCode, ' ⥭  ꥪ⮢');



  if not CreateNewQueue then
    begin
      {- ࠬ ﭨ । }
      CCode := ReadQueueCurrentStatus(QueueID, QueueStatus,
                                    NumberOfJobs, NumberOfServers,
                                    ServerIDList, StationList, 25);
      if CCode <> 0 then Error(CCode, ' ⥭ ﭨ ।');
      {-६  ⠭   ।  ᮥ }
      {  ࢥ஢  }
      CCode := SetQueueCurrentStatus(QueueID,
                            QS_CantAddJobs + QS_ServersCantAttach);
      if CCode <> 0 then Error(CCode, '  ﭨ ।');
      if NumberOfJobs <> 0 then
        if YesOrNo('। ' + QueueName + '  . ' +
                   ' 믮  ') then
          begin
            i := WhereY;
            repeat
              CCode := GetQueueJobList(QueueID, Count, StationList, 1);
              if CCode <> 0 then Error(CCode, ' ⥭ ।')
              else begin
                     GotoXY(1, i);
                     Write('⠫ : ', Count);
                   end;
            until Count = 0;
            WriteLn;
          end;
      {- 祭 ᢮ Q_USERS, Q_SERVERS  Q_OPERATORS }
      for i := 1 to 3 do
        begin
          SNumber := 1;
          repeat
            CCode := ReadPropertyValue(QueueName, QueueType,
                                       QueueProperty[i], SNumber,
                                       TempBuff, PropF, MoreS);
            if (CCode <> 0) and (CCode <> ERR_NoSuchSegment) then
              Error(CCode, ' ⥭ Bindery')
            else
             if CCode = 0 then
               begin
                 New(CurrentPtr);
                 with CurrentPtr^ do
                 begin
                   NextPtr := TopPtr;
                   PropName := QueueProperty[i];
                   Move(TempBuff, PropertyValue, SizeOf(TempBuff));
                 end;
                 TopPtr := CurrentPtr;
                 Inc(CountProperty);
                 Inc(SNumber);
               end;
          until CCode = ERR_NoSuchSegment;
        end; {for}
    end; {if}



  if not CreateNewQueue then
    begin
      CCode := DestroyQueue(QueueID);
      if CCode <> 0 then Error(CCode, '  㤠 ।');
    end;


  {-  । }
  CCode := CreateQueue(QueueName, QueueType, 0,
                       QueueDirPath, QueueID);
  if CCode <> 0 then Error(CCode, '  ᮧ ।');
  CCode := ChangePropertySecurity(QueueName, QueueType,
                 QueueProperty[2], LVL_Supervisor shl 4 + LVL_Logged);
  if CCode <> 0 then Error(CCode, '  ࠡ  Bindery');
  {- 㬮砭  । - Supervisor }
  CCode := AddBinderyObjectToSet(QueueName, QueueType,
                 QueueProperty[2], 'SUPERVISOR', OBJ_User);
  if CCode <> 0 then Error(CCode, '  ࠡ  Bindery');
  {- ID Supervisor`a }
  CCode := GetBinderyObjectID('SUPERVISOR', OBJ_User, SupervisorID);
  if CCode <> 0 then Error(CCode, '  ࠡ  Bindery');



  if not CreateNewQueue then
    begin
      while CountProperty > 0 do
        begin
          CurrentPtr := TopPtr;
          i := 0;
          with CurrentPtr^ do
          begin
            for i := 0 to 31 do
              if PropertyValue[i] <> 0 then
                begin
                  ObjID := SwapLongint(PropertyValue[i]);
                  CCode := GetBinderyObjectName(ObjID, ObjName, ObjType);
                  if CCode <> 0 then Error(CCode, ' ⥭ Bindery');
                  if ObjID <> SupervisorID then  {- 㦥   ᯨ᪥ }
                    begin
                      CCode := AddBinderyObjectToSet(QueueName, QueueType,
                                              PropName, ObjName, ObjType);
                      if CCode <> 0 then Error(CCode, '   Bindery');
                    end;
                end;
            TopPtr := NextPtr;
          end; {with}
          Dispose(CurrentPtr);
          Dec(CountProperty);
        end; {while}
      {-⠭ 祭 䫠  }
      CCode := SetQueueCurrentStatus(QueueID, QueueStatus);
      if CCode <> 0 then Error(CCode, '  ﭨ ।');
    end
  else
    begin
      {-᫨ ᮧ  ।,  ⠭ 짮⥫ }
      {  - 㯯 Everyone }
      CCode := AddBinderyObjectToSet(QueueName, QueueType,
                     QueueProperty[1], 'EVERYONE', OBJ_Group);
      if CCode <> 0 then Error(CCode, '  ࠡ  Bindery');
    end;


  if CreateNewQueue then
    begin
      WriteLn('Ok!  ࢥ ', ServerName);
      WriteLn('ᮧ । ', QueueName);
    end
  else
    begin
      WriteLn('Ok! 稩 ⠫ । ', QueueName);
      WriteLn('६饭  ', QueueDirPath);
      Count := 0;
      for i := 0 to 24 do
        if ServerIDList[i] <> 0 then Inc(Count);
      if Count = 0 then Halt;
      WriteLn(' ४⭮ ࠡ । 室 ⠭:');
      for i := 0 to Pred(Count) do
        begin
          CCode := GetBinderyObjectName(ServerIDList[i], ObjName, ObjType);
          if CCode <> 0 then Error(CCode, ' ⥭ Bindery');
          case ObjType of
            OBJ_PrintServer       : Write('ࢥ  ');
            OBJ_JobServer         : Write('ࢥ  ');
            OBJ_FileServer        : Write(' ࢥ ');
            OBJ_ArchiveServer     : Write('娢 ࢥ ');
            OBJ_RemoteBridgeServer: Write('ࢥ 㤠  ');
          else Write('ꥪ ');
          end; {of case}
          WriteLn(ObjName);
        end;
    end;
end.

